function translit(val) {
    if (!val || !val.replace) {
        return val;
    }
    val = val.replace(/а/gi, "a");
    val = val.replace(/б/gi, "b");
    val = val.replace(/в/gi, "v");
    val = val.replace(/г/gi, "g");
    val = val.replace(/д/gi, "d");
    val = val.replace(/е/gi, "e");
    val = val.replace(/ж/gi, "zh");
    val = val.replace(/з/gi, "z");
    val = val.replace(/и/gi, "i");
    val = val.replace(/й/gi, "i");
    val = val.replace(/к/gi, "k");
    val = val.replace(/л/gi, "l");
    val = val.replace(/м/gi, "m");
    val = val.replace(/н/gi, "n");
    val = val.replace(/о/gi, "o");
    val = val.replace(/п/gi, "p");
    val = val.replace(/р/gi, "r");
    val = val.replace(/с/gi, "s");
    val = val.replace(/т/gi, "t");
    val = val.replace(/у/gi, "u");
    val = val.replace(/ф/gi, "f");
    val = val.replace(/х/gi, "h");
    val = val.replace(/ц/gi, "c");
    val = val.replace(/ч/gi, "ch");
    val = val.replace(/ш/gi, "sh");
    val = val.replace(/щ/gi, "sch");
    val = val.replace(/ъ/gi, "'");
    val = val.replace(/ы/gi, "y");
    val = val.replace(/ь/gi, "'");
    val = val.replace(/э/gi, "e");
    val = val.replace(/ю/gi, "u");
    val = val.replace(/я/gi, "ya");
    return val;
}
(function(snetId, rules){

    var $ = jQuery.noConflict();


    function invoke(rules) {

//        log("Trying to parse for snetId="+snetId)

        var result = {
            uid: null
        }

        if (rules.uid) {
            result.uid = parseChains(rules.uid);
//            log("Parsed uid: "+result.uid)
        }


        if (rules.fields && rules.fields.length>0) {
            for (var i = 0; i < rules.fields.length; i++) {
                var val = parseChains(rules.fields[i])
                result[rules.fields[i].name] = val;
                val = translit(val);
//                log("Parsed field: "+rules.fields[i].name+" = "+val)
            }
        }

        return result;

    }


    function parseChains(rule) {
        for (var i = 0; i < rule.chains.length; i++) {
            var res = parseChain(rule.chains[i]);
            if (res!==undefined) {
                return res;
            }
        }
    }


    function parseChain(chain) {

//        log("Parsing next chain")

        if (chain.onlyIf && chain.onlyIf.length>0) {
            var condition = processCommands(chain.onlyIf);
            if (condition===undefined) {
                return undefined;
            }
        }
        else if (chain.unless && chain.unless.length>0) {
            condition = processCommands(chain.onlyIf);
            if (condition!==undefined) {
                return undefined;
            }
        }
        return processCommands(chain.commands, chain.type);


    }


    function processCommands(commands, type) {
        var isArray = "array" === type;
        var result = $;
        var chainStr = "";
        var stack = [];

        for (var i = 0; i < commands.length; i++) {
            var operator = commands[i];
            switch (operator.cmd) {
                case 'push':
                    if (result) {
                        stack.push(result);
                        chainStr += ".push()";
                    }
                    break;
                case 'join_stack':
                    result = stack.join(operator.arg);
                    chainStr += ".join_stack()";
                    break;
                case 'select':
                    result = jQuery(operator.arg);
                    chainStr += " jQuery(\""+operator.arg+"\")";
                    break;
                case 'attr':
                    result = result.attr(operator.arg);
                    chainStr += ".attr(\""+operator.arg+"\")";
                    break;
                case 'find':
                    result = result.find(operator.arg);
                    chainStr += ".find(\""+operator.arg+"\")";
                    break;
                case 'substr':
                    result = result.substring(operator.arg);
                    chainStr += ".substring("+operator.arg+")";
                    break;
                case 'replace':
                    result = result.replace(new RegExp(operator.pattern), operator.replace);
                    chainStr += ".replace("+operator.pattern+", "+operator.replace+")";
                    break;
                case 'html':
                    if (isArray) {
                        var res = [];
                        result.each(function() {
                            res.push($(this).html())
                        })
                        chainStr += ".each(x => x.html()).toArray()";
                        return res;
                    }
                    else {
                        result = result.html();
                        if (!result && operator.nullAsEmpty) {
                            result = ""
                        }
                        chainStr += ".html()";
                    }
                    break;
                case 'next':
                    result = result.next();
                    chainStr += ".next()";
                    break;
            }

            if (!result && result!="") {
                return result;
            }

        }

        return result;

    }


    var profile = invoke(rules);

    if (profile.uid) {
        self.port.emit("parser", {"snetId":snetId,"profile":profile})
    }




})(self.options.snetId, self.options.rules);

