$(function() {

    var firefoxAdapter = {

        sendMessage: function(msg) {
            self.port.emit(msg.context, {action: msg.action, data: msg.data})
        },


        requestCurrentUrl: function(callback) {
            self.port.once("request_current_url", function rcu(msg) {
                if (/^about:/.test(msg.data.url)) {
                    self.port.removeListener(rcu);
                } else {
                    callback(msg.data.url, msg.data.tabInfo);
                }
            });
            self.port.emit("share", {action: "request_url"})
        },

        requestCurrentTitle: function (callback) {
            self.port.once('take_title', function (title) {
                callback(title);
            });
            self.port.emit('get_share_title');
        },

        openWindow: function(params, cb) {

            if (cb) {
                self.port.once('share_init_message_received', function () {
                    cb();
                });
            }
            params.cmd = "post";
            self.port.emit("share", {action:"post", data: params});

        },

        openLink: function (link) {
            window.open(link);
        }

        , goto: function(url, tab) {
            params = {
                cmd : "mail",
                url: url
            };
            self.port.emit("share", {action:"post", data: params});
        }

    }


    var toolbarUI = new ToolbarUI(firefoxAdapter);
    self.port.on("toolbar_ui", function(msg) {
        toolbarUI.getMessageListener()({context: "toolbar_ui", action: msg.action, data: msg.data});
    });
    self.port.on("parse_search_results", function(tokens) {

        const songs = [];

        var addShareRegExp = /(?:\S+:\s*\S+\s*)*(?:aid:\s*([^,\s]+))(?:.+?)(?:oid:\s*([^,\s]+))(?:.+?)(?:hash:\s*'(\w+)')/g;
        const parseSongs = function () {
            addShareRegExp.lastIndex = 0;

            const $this = $(this);

            var url = $this.find("input:hidden").val();
            var artist = $this.find("div.title_wrap > b").text();
            var title = $this.find("div.title_wrap span.title").text();
            var duration = $this.find("div.duration").text();

            var addShareToken = $this.find("div.audio_add_wrap").clone().wrap('<p>').parent().html();
            var match = addShareRegExp.exec(addShareToken);

            var songId = match[1];
            var ownerId = match[2];
            var hash = match[3];

            url = url.replace(/,\d+$/, '');

            var song = {
                pid: ownerId,
                id: songId,
                url: url,
//                        length: j[3],
                duration: duration,
                artist: artist,
                name: title,
                hashAdd: hash
            };

            songs.push(song);


        };

        for (var i = 0; i < tokens.length; i++) {
            $(tokens[i]).each(parseSongs);
        }

        self.port.emit("parsed_search_results", songs)



    });
    toolbarUI.bind();
    firefoxAdapter.sendMessage({context: "vk_player", action:"request_model"})
});
